import pandas as pd
from rpy2.robjects import r
from collections import OrderedDict

rscript = '''\
male <-  round(rnorm(10, 165.0, 8.0), 1)
female <- round(rnorm(10, 161.0, 9.0), 1)
rdtf <- data.frame(male, female)
rownames(rdtf) <- c("a", "b", "c", "d", "e", "f", "g", "h", "i", "j")
'''
r(rscript)
rdtf = r['rdtf']
rownames = list(rdtf.rownames)
colnames = list(rdtf.colnames)
pod = OrderedDict()
for name in colnames:
    cobj = rdtf.rx2(name)
    pod[name] = list(cobj)
pdtf = pd.DataFrame(pod)
pdtf.index = rownames
print(pdtf)
