# prc03u.py (encoding: utf-8)
  # 身長の平均値が男女間で有意に異なるか t検定で検証
import pandas as pd
from rpy2.robjects import r
from textwrap import dedent
import pyrcmd as prc
prc.set_charset('utf-8')

src_file = 'data.csv'
rscript = dedent(u'''\
    dtf <- read.csv("%s", header=T, fileEncoding="%s")
    male = subset(dtf, 性別 == "男性")
    female = subset(dtf, 性別 == "女性")
    flag <- FALSE  # 不等分散を仮定
    t_test <- t.test(male$身長, female$身長, var.equal=flag)
    t_test
    ''') % (src_file, prc.get_charset(src_file))
sink_data = prc.rexec(rscript)  # Rコマンドの実行
t_test = r['t_test']  # rp2オブジェクト(ListVector)として取得
pod = prc.rp2pd(t_test)  # ListVectorを変換(OrderedDictになる)

print(u'＊t検定の結果に関する統計Rの表示')
print(sink_data)
print('')
print(u'＊t検定の結果に関する詳細表示')
prc.print_dict(pod)
