# prc01s.py (encoding: cp932)
  # g̕ϒljԂŗLӂɈقȂ邩 tŌ
  # ʂhtmlƂďo
import pandas as pd
from rpy2.robjects import r
from textwrap import dedent
import markdown as md
import pyrcmd as prc
prc.set_charset('cp932')

src_file = 'data.csv'
rscript = dedent(u'''\
    dtf <- read.csv("%s", header=T, fileEncoding="%s")
    male = subset(dtf,  == "j")
    female = subset(dtf,  == "")
    flag <- FALSE  # sU
    t_test <- t.test(male$g, female$g, var.equal=flag)
    t_test
    ''') % (src_file, prc.get_charset(src_file))
md_tpl = dedent(u'''\
    # g̕ϒlɊւ錟\n
    @g̕ϒljԂňقȂ邩邽 t()sB\n
    @Ȑl͎̂ƂB\n
    - v tl: {t}
    - Rx(df): {df}
    - Lӊm(pl): {p_value}
    - ϒl: j {mean_of_x:.1f},  {mean_of_y:.1f}
    - 95M: {conf_int[0]:.4f} -- {conf_int[1]:.4f}\n
    @LӊmႢƂ(p<0.05)AϒlȂƔfB\n
    @ȂAv̓\tgȐo͌ʂ͉̂ƂB\n
    ~~~~
    {sink}
    ~~~~\n
    ----\n\n
    ''')

sink_data = prc.rexec(rscript)  # RR}h̎s
t_test = r['t_test']  # rp2IuWFNg(ListVector)ƂĎ擾
pod = prc.rp2pd(t_test)  # ListVectorϊ(OrderedDictɂȂ)
fod = prc.format_od(pod)  # ev[gpɕϊ
fod['sink'] = sink_data  # vȐo͂gݓ
md_src = md_tpl.format(**fod)  # markdowne̐
title = u't'  # html̃^Cg
body = md.markdown(md_src, ["fenced_code"])
html = prc.html_template % ('utf-8', title, body)
prc.write_text("prc01s.htm", html, 'utf-8')
