# prc02s.py (encoding: cp932)
  # g敪~ʂ̃NXWv\JCQ挟ɂ
  # vʓ̂قAϑxAςݎc\
  # docx([h)o
  # jinja2, pypandoc 𗘗p
import os
import pandas as pd
from rpy2.robjects import r
from jinja2 import Template
from textwrap import dedent
import pypandoc
import pyrcmd as prc
prc.set_charset('cp932')

src_file = 'data.csv'
rscript = dedent(u'''\
    dtf <- read.csv("%s", header=T, fileEncoding="%s")
    dtf$ <- factor(dtf$, levels=c("j", ""),
      labels=c("j", ""))
    cc <- cut(dtf$g, breaks=c(-Inf, 155, 165, 175, Inf),
        labels=c("155", "155`165", "165`175", "175ȏ"), right=FALSE)
    dtf <- cbind(dtf, g敪=cc)
    tbl <- table(dtf$g敪, dtf$)
    chi_test <- chisq.test(tbl)
    chi_test
    ''') % (src_file, prc.get_charset(src_file))
md_tpl = Template(dedent(u'''\
    # ug敪v~uʁṽJCQ挟茋\n
    @jԂ̐g̈Ⴂ݂邽߁Åϑx̕\JCQ挟ɂB\n
    {{observed}}\n
    @茋ʂ̎Ȑl͎̂ƂB\n
    - v(JCQl): {{X_squared}}
    - Rx(df): {{df}}
    - Lӊm(pl): {{p_value}}\n
    @Lӊm̒lႢƂ(p<0.05)A
    ug敪vƁuʁv̊֌W͓ƗȂ̂ł͂ȂA
    LӂȊ֘AƔfB\n
    @ŁAςݎc݂Ɖ̂ƂB\n
    {{stdres}}\n
    @݂ƁA165ł͏LӂɑA
    A165ȏł͒jLӂɑƂB\n
    '''))

prc.rexec(rscript, sink=False)  # RR}h̎s
chi_test = r['chi_test']  # rp2IuWFNg(ListVector)ƂĎ擾
pod = prc.rp2pd(chi_test)  # ListVectorϊ(OrderedDictɂȂ)
fod = prc.format_od(pod)
md_src = md_tpl.render(fod)  # markdowne̐
md_file = 'temp.md'
prc.write_text(md_file, md_src, 'utf-8')  # markdownet@C
pypandoc.convert_file(md_file, 'docx',
    outputfile='prc02s.docx', format='md')
os.unlink(md_file)
