# prc03s.py (encoding: cp932)
  # jinja2̗̏Bhtml𐶐
  # gƑ̏d̕z󋵂\Bsummary, hist, shapiro.test
import pandas as pd
from rpy2.robjects import r
from jinja2 import Template
from textwrap import dedent
import markdown as md
import pyrcmd as prc
prc.set_charset('cp932')

src_file = 'data.csv'
rscript = dedent(u'''\
    dtf <- read.csv("%s", header=T, na.string="", fileEncoding="%s")
    jp_names <- c("g", "̏d")
    eng_names <- c("height", "weight")
    xx = list()  # vʂ邽߂̋̃Xg
    for (i in 1:length(jp_names)) {
        jp <- jp_names[i]
        eng <- eng_names[i]
        vct <- dtf[[jp]]  # ڂ̗vct
        vct <- vct[!is.na(vct)]  # l̏
        smr <- summary(vct)  # z̗v𓾂
        shp <- shapiro.test(x=vct)  # Ǩ
        xx[[eng]] <- list(summary=smr, shapiro=shp)
        xx[[eng]]$name <- jp
        fname <- sprintf("prc03s_%%s.png", eng)
        png(fname, width=240, height=240)
        hist(vct, main=eng)
        dev.off()  # `foCX
        xx[[eng]]$png_name <- fname
    }
    ''') % (src_file, prc.get_charset(src_file))

md_tpl = Template(dedent(u'''\
    # {{name}}̕z\n
    @{{name}}̕z(summary)͉̂ƂB\n
    {{summary}}\n
    @qXgO`Ɖ̂悤ɂȂB\n
    ![{{name}}̃qXgO]({{png_name}})\n
    @K؂邽 shapiro.test sƂA
    ̂悤ȌʂB\n
    - v W: {{shapiro.W}}
    - Lӊm p: {{shapiro.p_value}}\n
    {% if shapiro.p_value < 0.05 %}
    {{name}}ɂẮAp<0.05 ł邱Ƃ
    uKzɑĂv(A)pB\n
    ܂AKzł͂ȂƔfłB
    {% else %}
    {{name}}ɂẮAp>=0.05 ł邱Ƃ
    uKzɑĂv(A)płȂB\n
    ܂AKzɑĂƂ݂邱ƂłB
    {% endif %}
    --------\n\n
    '''))

prc.rexec(rscript, sink=False)  # RR}h̎s
xx = r['xx']  # rpy2̃IuWFNg𓾂
pod = prc.rp2pd(xx)  # pandas^Ȃǂɕϊ
for key in ['height', 'weight']:
    ser = pod[key]['summary']  # summary̌(Series)
    ser = ser.round(2)  # l̂܂ߏ
    df = pd.concat([ser], axis=1).T  # DataFrameɕϊ
    pod[key]['summary'] = df
fod = prc.format_od(pod, index=False)  # ev[gň悤ɕϊ

md_src = ''
for key in ['height', 'weight']:
    md_src = md_src + md_tpl.render(fod[key])
title = u'z󋵂̊mFƐǨ'  # html̃^Cg
body = md.markdown(md_src, extensions=["tables"])
html = prc.html_template % ('utf-8', title, body)
prc.write_text("prc03s.htm", html, 'utf-8')
